var cocos = require('cocos2d')
    ,geom = require('geometry')
    ,util = require('util');

function Ball (){
    Ball.superclass.constructor.call(this);

    var sprite = new cocos.nodes.Sprite({
          file: '/resources/sprites.png',
          rect: new geom.Rect(64,0,16,16)
    })

    sprite.anchorPoint = new geom.Point(0,0);
    this.addChild({child: sprite});
    this.contentSize = sprite.contentSize;

    this.velocity = new geom.Point(60,-120);
    this.scheduleUpdate();

}

Ball.inherit(cocos.nodes.Node,{
  velocity: null,

  update: function(dt){
    var pos = util.copy(this.position),
        vel = util.copy(this.velocity);

    pos.x += dt * vel.x;
    pos.y += dt * vel.y;

    this.position = pos;

    this.testBatCollision();
    this.testEdgeCollision(); 
  },

  testBatCollision: function(){
    var vel = util.copy(this.velocity),
        ballBox = this.boundingBox;

    batBox = this.parent.bat.boundingBox;

    if(vel.y < 0){
      if(geom.rectOverlapsRect(ballBox, batBox)){
        console.log("Hit the Bat");
        vel.y *= -1;
      }
    }
    this.velocity = vel;
  },

  testEdgeCollision: function(){
    //console.log("Testing Edge Collision");
    var vel = util.copy(this.velocity),
        ballBox = this.boundingBox;

    var winSize = cocos.Director.sharedDirector.winSize;
        console.log(vel.y);
        console.log(geom.rectGetMinY(ballBox));
            // Moving left and hit left edge
        if (vel.x < 0 && geom.rectGetMinX(ballBox) < 0) {
            // Flip X velocity
            console.log("Hit the left, while moving left");
            vel.x *= -1;
        }

        // Moving right and hit right edge
        if (vel.x > 0 && geom.rectGetMaxX(ballBox) > winSize.width) {
            // Flip X velocity
            console.log("Hit right edge while moving left");
            vel.x *= -1;
        }

        if(vel.y > 0 && geom.rectGetMaxY(ballBox) > winSize.height){
            vel.y *= -1;
        }

        if(vel.y < 0 && geom.rectGetMinY(ballBox) < 0){
          this.parent.restart();
        }


        this.velocity = vel;
    } 
})
module.exports = Ball;