"use strict"  // Use strict JavaScript mode

// Pull in the modules we're going to use
var cocos  = require('cocos2d')   // Import the cocos2d module
  , nodes  = cocos.nodes          // Convenient access to 'nodes'
  , events = require('events')    // Import the events module
  , geom    = require('geometry')  // Import the geometry module
  , ccp    = geom.ccp              // Short hand to create points
  , Bat    = require('/Bat')      //Importing Bat 
  , Ball   = require('/Ball')     //Import Ball
// Convenient access to some constructors
var Layer    = nodes.Layer
  , Scene    = nodes.Scene
  , Label    = nodes.Label
  , Director = cocos.Director

/**
 * @class Initial application layer
 * @extends cocos.nodes.Layer
 */
function Breakout () {
    // You must always call the super class constructor
    Breakout.superclass.constructor.call(this);

    var s = cocos.Director.sharedDirector.winSize;
    this.isMouseEnabled = true;

    var bat = new Bat();
    bat.position = new geom.Point(600, s.height - 280);
    this.addChild(bat);
    this.bat = bat;

    var ball = new Ball();
    ball.position = new geom.Point(600, s.height - 100);
    this.addChild(ball);
    this.ball = ball;
}

// Inherit from cocos.nodes.Layer
Breakout.inherit(cocos.nodes.Layer,{
  bat:null,
  ball: null,

  mouseMoved: function (evt) {
      var bat = this.bat;

      var batPos = bat.position;
      batPos.x = evt.locationInCanvas.x;
      bat.position = batPos;
  },

  restart: function () {
    var director = cocos.Director.sharedDirector

    // Create a scene
    var scene = new cocos.nodes.Scene()

    // Add our layer to the scene
    scene.addChild(new Breakout())

    director.replaceScene(scene)
  }

});

/**
 * Entry point for the application
 */
function main () {
    // Initialise application

    // Get director singleton
    var director = Director.sharedDirector;

    // Wait for the director to finish preloading our assets
    events.addListener(director, 'ready', function (director) {
        // Create a scene and layer
        var scene = new Scene()
          , layer = new Breakout()

        // Add our layer to the scene
        scene.addChild(layer);

        // Run the scene
        director.replaceScene(scene);
    })

    // Preload our assets
    director.runPreloadScene();
}


exports.main = main;
